/************************************************
*	talloc - test the dsalloc functions, by		*
*	allocating ten blocks, and intentionally	*
*	damaging the seventh one, freeing the third	*
*	one, and doing a dump.						*
************************************************/

#include <stdio.h>		/* NULL, printf			*/
#include "dsdebug.h"	/* function prototypes	*/

void main(void)
	{
	int i;
	char far *m[10];

	/* First, allocate 10 chunks of memory */
	for (i=0; i<10; i++)
		if ((m[i]=(char far *)malloc(45))==fNULL)
			printf( "Error! could not allocate "
					"chunk #%i!\n",i);

	puts("\n\nAfter allocation ... here is what "
		"the chunks of RAM look like:");
	dsAdump(stdout);

	puts("\n\nNow, free blocks 4 & 10, damage "
		 "block 7, and then free block 1");
	free(m[3]);				/* free the third	*/
	free(m[9]);				/* the tenth		*/
	for (i=0; i<50; i++)	/* Damage the 7th	*/
		m[6][i]='*';		/* chunk of ram		*/
	free(m[0]);				/* and the first	*/

	puts("\nNow, we have damaged #7, released #1 "
		"and #9 ... RAM looks like:");
	dsAdump(stdout);		/* Dump the nodes	*/
	}
